package org.apache.ojb.broker.metadata;

import org.apache.ojb.broker.metadata.fieldaccess.AnonymousPersistentFieldForInheritance;

/* Copyright 2003-2004 The Apache Software Foundation
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

public class AnonymousObjectReferenceDescriptor extends ObjectReferenceDescriptor
{
    private static final long serialVersionUID = -9132555799710533265L;
    
    public static final String ANONYMOUS_NAME = null;
    
	public AnonymousObjectReferenceDescriptor(ClassDescriptor descriptor)
	{
		super(descriptor);
	}

	public void setPersistentField(Class c, String fieldname)
    {
        // BRJ :
        // no field name for anonymous 'super' reference to
        // prevent using this reference in queries.
	    //
        m_PersistentField = new AnonymousPersistentFieldForInheritance(m_ClassDescriptor, ANONYMOUS_NAME);
    }
}

