package org.apache.ojb.broker.metadata;

import java.util.Iterator;
import java.io.FileOutputStream;

import junit.framework.TestCase;
import org.apache.ojb.broker.TestHelper;
import org.apache.ojb.broker.PBKey;

/**
 * This TestClass tests the RepositoryPersitors facilities for
 * reading and writing a valid repository.
 */
public class RepositoryPersistorTest extends TestCase
{
	public static void main(String[] args)
	{
		String[] arr = { RepositoryPersistorTest.class.getName()};
		junit.textui.TestRunner.main(arr);
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (24.12.2000 00:33:40)
	 */
	public RepositoryPersistorTest(String name)
	{
		super(name);
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (06.12.2000 21:58:53)
	 */
	public void setUp()
	{
	}

	/**
	 * Insert the method's description here.
	 * Creation date: (06.12.2000 21:59:14)
	 */
	public void tearDown()
	{

	}

	/** Test storing/read repository.*/
	public void testStoreReadRepository() throws Exception
	{
		String filename = "test_respository.xml";
        DescriptorRepository repository = MetadataManager.getInstance().getRepository();
        ConnectionRepository conRepository = MetadataManager.getInstance().connectionRepository();
        Iterator iter = repository.iterator();
        int numClasses = 0;
        while (iter.hasNext())
        {
            iter.next();
            numClasses++;
        }

        RepositoryPersistor persistor = new RepositoryPersistor();
        FileOutputStream fos = new FileOutputStream(filename);
        persistor.writeToFile(repository, conRepository, fos);

        DescriptorRepository second = persistor.readDescriptorRepository(filename);
        iter = second.iterator();
        int numClasses2 = 0;
        while (iter.hasNext())
        {
            iter.next();
            numClasses2++;
        }
        assertEquals("read in persisted repository should have same number of classes",
            numClasses, numClasses2);
        assertTrue(numClasses2 > 0);
	}

    /** Test storing/read repository.*/
	public void testStoreReadConnectionRepository() throws Exception
	{
		String filename = "test_repository_database.xml";
        DescriptorRepository repository = MetadataManager.getInstance().getRepository();
        ConnectionRepository conRepository = MetadataManager.getInstance().connectionRepository();
        int connectionCount = conRepository.getAllDescriptor().size();

        FileOutputStream fos = new FileOutputStream(filename);
        RepositoryPersistor persistor = new RepositoryPersistor();
        persistor.writeToFile(repository, conRepository, fos);

        ConnectionRepository second = persistor.readConnectionRepository(filename);
        int connectionCount2 = second.getAllDescriptor().size();

        PBKey defaultKey = second.getStandardPBKeyForJcdAlias(TestHelper.DEF_JCD_ALIAS);
        assertNotNull(defaultKey);
        assertEquals(TestHelper.DEF_KEY, defaultKey);

        assertTrue(connectionCount2 > 0);
        assertEquals("read in persisted connection repository should have same number of classes",
            connectionCount, connectionCount2);
	}
}
